DECLARE SUB TestTx ()
DECLARE SUB Rectangle ()
DECLARE SUB Dot ()
DECLARE SUB DrawLine ()
DECLARE SUB Bar ()
DECLARE SUB UserPattern ()
DECLARE SUB DrawCircle ()
DECLARE SUB Ellipse ()
DECLARE SUB Arc ()
DECLARE SUB PieSlice ()
DECLARE SUB Scale ()
DECLARE SUB Init (COLOR1!)

CALL TestTx

OPEN "LPT3" FOR OUTPUT AS #1

PRINT #1, CHR$(14); "[M18CU1,0]"
CALL Dot
CALL DrawLine
CALL Rectangle
CALL Bar
CALL UserPattern
CALL DrawCircle
CALL Ellipse
CALL Arc
CALL PieSlice
CALL Scale

PRINT #1, CHR$(14); "[M3CU1,1]"
CLOSE
END

DATA &H50,&H53,&H56,&HBE,&H00,&H00,&H2E,&HC7,&H04,&H00,&H00,&HB8,&H00,&HDB,&HCD,&H2F
DATA &H3C,&HFF,&H75,&H12,&H81,&HFB,&H50,&H54,&H75,&H0C,&HB8,&H11,&H00,&HCD,&H79,&H75
DATA &H05,&h2E,&HC7,&H04,&H01,&H00,&H5E,&H5B,&H58,&HCB
REM μTXBASIC.ASM

SUB Arc
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   R% = INT(RND * 50) + 20
   SA% = INT(RND * 340) + 10
   EA% = INT(RND * 340) + 10
   IF (X1% + R% < 639) AND (Y1% + R% < 449) AND (X1% - R% > 0) AND (Y1% - R% > 0) AND (ABS(SA% - EA%) > 50) THEN
      PRINT #1, CHR$(14); "[ST"; STR$(INT(RND * 12)); "]";
      PRINT #1, CHR$(14); "[E"; STR$(X1%); ","; STR$(Y1%); ","; STR$(SA%); ","; STR$(EA%); ","; STR$(R%); ","; STR$(R%); ",0]";
   END IF
WEND
END SUB

SUB Bar
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   X2% = INT(RND * 638) + 1
   Y2% = INT(RND * 448) + 1
   PRINT #1, CHR$(14); "[ST"; STR$(INT(RND * 12)); "]";
   PRINT #1, CHR$(14); "[B"; STR$(X1%); ","; STR$(Y1%); ","; STR$(X2%); ","; STR$(Y2%); "]";
   PRINT #1, CHR$(14); "[CO15R"; STR$(X1%); ","; STR$(Y1%); ","; STR$(X2%); ","; STR$(Y2%); "]";
WEND
END SUB

SUB Dot
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   PRINT #1, CHR$(14); "[D"; STR$(INT(RND * 638) + 1); ","; STR$(INT(RND * 448) + 1); "]";
WEND
END SUB

SUB DrawCircle
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   R% = INT(RND * 50) + 10
   IF (X1% + R% < 639) AND (Y1% + R% < 449) AND (X1% - R% > 0) AND (Y1% - R% > 0) THEN
      PRINT #1, CHR$(14); "[C"; STR$(X1%); ","; STR$(Y1%); ","; STR$(R%); "]";
   END IF
WEND
END SUB

SUB DrawLine
CALL Init(0)
PRINT #1, CHR$(14); "[X1]";
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   PRINT #1, CHR$(14); "[L"; STR$(X1%); ","; STR$(Y1%); ","; STR$(640 - X1%); ","; STR$(450 - Y1%); "]";
WEND
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   X2% = INT(RND * 638) + 1
   Y2% = INT(RND * 448) + 1
   PRINT #1, CHR$(14); "[L"; STR$(X1%); ","; STR$(Y1%); ","; STR$(X2%); ","; STR$(Y2%); "]";
WEND
PRINT #1, CHR$(14); "[X0]";
END SUB

SUB Ellipse
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   XR% = INT(RND * 50) + 10
   YR% = INT(RND * 50) + 10
   IF (X1% + XR% < 639) AND (Y1% + YR% < 449) AND (X1% - XR% > 0) AND (Y1% - YR% > 0) THEN
      PRINT #1, CHR$(14); "[E"; STR$(X1%); ","; STR$(Y1%); ",0,360,"; STR$(XR%); ","; STR$(YR%); ",0]";
   END IF
WEND
END SUB

SUB Init (COLOR1)
PRINT #1, CHR$(14); "[ST0CO"; STR$(COLOR1); "B0,0,639,449CO15R0,0,639,449]"
END SUB

SUB PieSlice
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   R% = INT(RND * 50) + 20
   SA% = INT(RND * 340) + 10
   EA% = INT(RND * 340) + 10
   IF (X1% + R% < 639) AND (Y1% + R% < 449) AND (X1% - R% > 0) AND (Y1% - R% > 0) AND (ABS(SA% - EA%) > 50) THEN
      PRINT #1, CHR$(14); "[ST"; STR$(INT(RND * 12)); "]";
      PRINT #1, CHR$(14); "[E"; STR$(X1%); ","; STR$(Y1%); ","; STR$(SA%); ","; STR$(EA%); ","; STR$(R%); ","; STR$(R%); ",2,"; STR$(INT(RND * 16)); "]";
   END IF
WEND
END SUB

SUB Rectangle
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   X2% = INT(RND * 638) + 1
   Y2% = INT(RND * 448) + 1
   PRINT #1, CHR$(14); "[R"; STR$(X1%); ","; STR$(Y1%); ","; STR$(X2%); ","; STR$(Y2%); "]";
WEND
END SUB

SUB Scale
CALL Init(0)
PRINT #1, CHR$(14); "[SC16MAl100,100,200,200lt400,160,lt100,100]";
PRINT #1, CHR$(14); "[X1]";

FOR I = 0 TO 28
   PRINT #1, CHR$(14); "[SC"; STR$(I); "me]";
   IF I < 28 THEN
      FOR J = 0 TO 500
      NEXT J
      PRINT #1, CHR$(14); "[ME]";
   END IF
NEXT I

WHILE INKEY$ = ""
WEND

FOR I = 28 TO 0 STEP -1
   PRINT #1, CHR$(14); "[SC"; STR$(I); "me]";
   IF I < 28 THEN
      FOR J = 0 TO 500
      NEXT J
      PRINT #1, CHR$(14); "[ME]";
   END IF
NEXT I

PRINT #1, CHR$(14); "[x0sc16]";

END SUB

SUB TestTx
DIM a%(50)
DEF SEG = VARSEG(a%(0))
RESTORE
FOR I% = 0 TO 41
    READ D%
    IF I% = 4 THEN
       D% = VARPTR(a%(49)) MOD 256
    ELSEIF I% = 5 THEN
       D% = VARPTR(a%(49)) / 256
    END IF
    POKE VARPTR(a%(0)) + I%, D%
NEXT I%

CALL ABSOLUTE(VARPTR(a%(0)))
DEF SEG
IF a%(49) = 0 THEN
   PRINT "Please run TX.COM first"
   END
END IF

END SUB

SUB UserPattern
CALL Init(0)
WHILE INKEY$ = ""
   PRINT #1, CHR$(14); "[CO"; STR$(INT(RND * 16)); "]";
   X1% = INT(RND * 638) + 1
   Y1% = INT(RND * 448) + 1
   X2% = INT(RND * 638) + 1
   Y2% = INT(RND * 448) + 1
   PRINT #1, CHR$(14); "[DS";
   FOR I = 0 TO 7
      PRINT #1, STR$(INT(RND * 256)); ",";
   NEXT I
   PRINT #1, CHR$(14); "]";
   PRINT #1, CHR$(14); "[ST13]";
   PRINT #1, CHR$(14); "[B"; STR$(X1%); ","; STR$(Y1%); ","; STR$(X2%); ","; STR$(Y2%); "]";
   PRINT #1, CHR$(14); "[CO15R"; STR$(X1%); ","; STR$(Y1%); ","; STR$(X2%); ","; STR$(Y2%); "]";
WEND
END SUB

